"use strict";const path=require("path"),fs=require("fs"),chalk=require("chalk"),inquirer=require("inquirer"),adbCommander=require("adb-commander"),{launchServer:launchServer}=require("@hap-toolkit/server"),{compile:compile}=require("./compile"),{colorconsole:colorconsole}=require("@vivo-hap-toolkit/shared-utils"),{downloadFile:downloadFile,getQuickappDebuggerUrl:getQuickappDebuggerUrl,getQuickappPreviewUrl:getQuickappPreviewUrl,sendReq:sendReq,getClients:getClients,checkQuickappDir:checkQuickappDir,getCardContent:getCardContent}=require("./utils"),{recordClient:recordClient,clearProjectRecord:clearProjectRecord}=require("@vivo-hap-toolkit/shared-utils/lib/record-client"),{clientRecordPath:clientRecordPath}=require("@vivo-hap-toolkit/shared-utils/config"),ipRegExp=/^(?:(?:25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.){3}(?:25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)$/,CLIENT_PORT=39517;async function connectDevice(e=""){try{const r="是，连接新的wifi设备";if(!e){if((await inquirer.prompt([{name:"type",type:"list",message:"（USB设备会自动连入）选择是否要连接新的wifi设备，稍后需填写其IP地址:",choices:[r,"跳过，保持已连接的设备"]}])).type!==r)return Promise.resolve();e=(await inquirer.prompt([{name:"ip",message:'请输入设备在wifi下的ip地址(如192.168.1.1)，并确保电脑与设备在同一wifi下。若需输入多个ip，请以","分隔:',default:null}])).ip}if(0===e.length)return colorconsole.info("没有输入任何ip地址，将连接已连接过的设备"),Promise.resolve();const o=e.trim().split(","),t=o.filter(e=>!ipRegExp.test(e));if(!t||!t.length){const e=Array.from(o,e=>adbCommander.exeCommand(`adb connect ${e}:5555`).then(({result:r,err:o})=>((o||r.indexOf("failed")>=0)&&(colorconsole.error(`wifi连接ip： "${e}" 的设备失败了`),process.exit()),colorconsole.info(`wifi连接ip： "${e}" 的设备成功了`),recordClient(clientRecordPath,{ip:e,port:39517}),Promise.resolve())));return Promise.all(e).then(()=>(colorconsole.log("所有新的WIFI设备连接完毕"),Promise.resolve())).catch(()=>{process.exit()})}t.map(e=>{colorconsole.error(`ip: ${e} is invalid IP`)}),process.exit()}catch(e){return Promise.reject(new Error("连接设备出错，错误信息："+e.message))}}async function getConnectDevices(e=!0){try{return adbCommander.deviceList().then(({deviceList:r,err:o})=>{if(o){const e="获取adb设备连接信息出错";colorconsole.throw(e,o)}if(r.length>0)return e&&colorconsole.info(`通过adb连接的设备的有： ${chalk.yellow(r.join(", "))}.`),Promise.resolve(r);{const e="当前无设备连接，请依次检查以下准备工作是否完成：\n  1. 设备是否启动;\n  2. 是否处于同一局域网WI-FI;\n  3. 设备是否可以USB连接电脑;";colorconsole.throw(e)}})}catch(e){return Promise.reject(new Error(e.message))}}async function downloadApk(e,r){let o="";const{apkVersion:t}=e;o=r?getQuickappDebuggerUrl(t):getQuickappPreviewUrl(t);const n=path.basename(o),c=path.join(__dirname,"./apk/",n);return fs.existsSync(c)?(colorconsole.log("安装包已下载过，现使用缓存文件安装"),c):downloadFile(o,n).then(e=>(colorconsole.info(e),c)).catch(e=>{colorconsole.error("下载安装包失败",e),process.exit()})}async function installApk(e,r=[],o,t,n){const{forceInstall:c=!1}=e;try{const e=Array.from(r,e=>adbCommander.isInstalled(e,t).then(async({isInstalled:r,err:l})=>l?(colorconsole.error(`在设备 "${chalk.yellow(e)}" 上安装应用 "${chalk.yellow(n)}" 失败了，错误信息：${JSON.stringify(l)} `),Promise.reject(new Error(JSON.stringify(l)))):!1===r||c?(await adbCommander.uninstall(e,t),colorconsole.log(`开始在设备 "${chalk.yellow(e)}" 上安装应用："${chalk.yellow(n)}" `),adbCommander.install(e,o).then(({result:r,err:o})=>o?(colorconsole.error(`在设备 "${chalk.yellow(e)}" 上安装应用 "${chalk.yellow(n)}" 失败了，请排查问题后重试 `),Promise.reject(new Error(`在设备 "${chalk.yellow(e)}" 上安装应用 "${chalk.yellow(n)}" 失败了，请排查问题后重试 `))):adbCommander.isInstalled(e,t).then(({isInstalled:r,err:o})=>{if(!0===r)return colorconsole.info(`在设备 "${chalk.yellow(e)}" 上安装应用 "${chalk.yellow(n)}" 成功 `),Promise.resolve()}))):(colorconsole.warn(`在设备 "${chalk.yellow(e)}" 上已经安装过应用 "${chalk.yellow(n)}"，因此这次安装没有继续`),Promise.resolve())));return Promise.all(e).then(()=>(colorconsole.log("所有设备安装完毕"),Promise.resolve())).catch(()=>{process.exit()})}catch(e){return Promise.reject(e)}}async function startServer(e){const{address:r}=await launchServer({clearRecords:!0});return await compile("native","dev",!0,e),r}async function installdbg(e,r=!0){try{const{ip:o}=e;r&&await connectDevice(o);const t=await getConnectDevices(r),n=await queryDevice(t,"安装快应用调试器"),c=await downloadApk(e,!0);return await installApk(e,n,c,"org.hapjs.debugger","快应用调试器"),Promise.resolve("所有设备安装快应用调试器成功")}catch(e){return Promise.reject(new Error("安装调试器失败，错误信息："+e.message))}}async function installmkp(e,r=!0){try{const{ip:o}=e;r&&await connectDevice(o);const t=await getConnectDevices(r),n=await queryDevice(t,"安装快应用预览版"),c=await downloadApk(e);return await installApk(e,n,c,"org.hapjs.mockup","快应用预览版"),Promise.resolve("所有设备安装快应用预览版成功")}catch(e){return Promise.reject(new Error("安装快应用预览版失败，错误信息："+e.message))}}async function queryDevice(e,r=""){if(!e||0===e.length)return void colorconsole.error("尚没有连接任何设备，请确认后重试");const o=(await inquirer.prompt([{name:"device",type:"list",message:`请选择需要执行命令"${r}"的设备:`,choices:[...e,"全部已连接设备"]}])).device;return"全部已连接设备"===o?e:[o]}async function startDebugger(e=[],r){colorconsole.info("正在为已连接的设备启动调试器中...");const o=Array.from(e,e=>adbCommander.exeCommand(`adb -s ${e} shell am start -n "org.hapjs.debugger/.MainActivity" ${r}`).then(({err:r})=>r?(colorconsole.error(`在设备 "${chalk.yellow(e)}" 上启动"快应用调试器"失败，请排查问题后重试`),Promise.reject(new Error(JSON.stringify(r)))):(colorconsole.info(`在设备 "${chalk.yellow(e)}" 上启动"快应用调试器"成功`),Promise.resolve())));return Promise.all(o).then(()=>(colorconsole.info("所有设备的调试器启动完毕"),Promise.resolve())).catch(()=>{process.exit()})}async function runapp(e,r=!0,o=!0){try{const{debugMode:t=!1,cardMode:n=!1}=e;let c="",l="",i="";const a=process.cwd();if(checkQuickappDir(a),n){colorconsole.warn("请在安卓系统中开启快应用调试器与预览版引擎的「自启动」与「关联启动」权限");const e=getCardContent(a);if(e){const r=Object.keys(e);if(r.length>1){const o=await inquirer.prompt([{name:"cardName",type:"list",message:"请选择调试的卡片:",choices:r}]);l=e[o.cardName].path||"/"+o.cardName}else l=e[r[0]].path||"/"+r[0];i+="-e cardMode true -e cardPath "+l}}clearProjectRecord(clientRecordPath),c=await startServer(e),i+=" -e path "+c,c||(colorconsole.error("启动本地快应用服务失败，请排查后重试"),process.exit()),o&&await connectDevice();const s=await getConnectDevices(r);s&&0!==s.length||(colorconsole.error("没有可用的连接设备！"),process.exit()),await startDebugger(s,i),setTimeout(async()=>{const e=await getClients();e||(colorconsole.error("没有可用的连接设备！"),process.exit());for(let r of e){const{sn:e,ip:o}=r;if("127.0.0.1"===o&&e.includes(":5555"))continue;const n=e&&e.length>0?e:o,c=()=>{colorconsole.error(`"${n}" 设备获取运行平台列表时错误,延迟3s后再次请求`),setTimeout(()=>{l()},3e3)},l=async()=>{let e=await sendReq(r,"/availablePlatforms");e||c(),e=JSON.parse(e);const{availablePlatforms:l}=e;if(l){let e;if(0===l.length)return void colorconsole.error(o+" 设备尚未安装快应用引擎");if(1===l.length)e=l[0].pkg;else if(l.length>1){const r=await inquirer.prompt([{name:"name",type:"list",message:`在设备"${n}"上检测到多个快应用引擎，请选择运行平台:`,choices:l}]);l.forEach(o=>{o.name===r.name&&(e=o.pkg)})}"OK"===await sendReq(r,"/platform",{selectedPlatform:e})&&sendReq(r,"/update",{debug:t})}else c()};await l()}},3e3)}catch(e){return Promise.reject(new Error("运行RPK到设备上出错，错误信息："+e.message))}}async function installAndRun(e){try{const r=process.cwd();checkQuickappDir(r),await installdbg(e),await installmkp(e,!1),await runapp(Object.assign({},e,{enableServerWatch:!0}),!1,!1)}catch(e){return Promise.reject(new Error("一键调试出错，错误信息："+e.message))}}async function getAvailablePlatform(e){try{const{ip:r,port:o,sn:t}=e;r&&ipRegExp.test(r)||(colorconsole.error("没有传入正确的ip地址，示例 --ip 127.0.0.1"),process.exit()),o||(colorconsole.error("没有传入正确的端口地址，示例 --port 39517"),process.exit()),t||(colorconsole.error('没有传入正确的设备序列号，可通过"adb devices"指令查看已连接的设备序列号 \n 如果是WIFI连接的设备，格式为 "ip地址:5555"'),process.exit());let n={ip:r,port:o};const c=()=>{colorconsole.error("设备获取运行平台错误,延迟3s后再次请求"),setTimeout(()=>{l()},3e3)},l=async()=>{let e=await sendReq(n,"/availablePlatforms");if(e)if(e=JSON.parse(e),e.availablePlatforms){const r=e.availablePlatforms;colorconsole.info(`设备"${t}"的快应用引擎列表有：${r.join(", ")}`)}else c();else c()};adbCommander.exeCommand(`adb -s ${t} shell am start -n "org.hapjs.debugger/.MainActivity"`).then(({err:e})=>{e&&(colorconsole.error("调试器没有正常启动，请检查是否已安装"),process.exit()),colorconsole.info(`调试器成功运行在设备"${chalk.yellow(t)}"`),colorconsole.info(`设备"${t}"获取快应用引擎列表中...`),l()})}catch(e){colorconsole.error("获取设备上的快应用引擎列表出错，错误信息："+e.message)}}async function getAllConnectedDevices(e){try{return adbCommander.deviceList().then(({deviceList:e,err:r})=>{if(!r)return Promise.resolve(e);colorconsole.throw(r)})}catch(e){return Promise.reject(new Error("获取所有连接上的设备数组出错，错误信息："+e.message))}}module.exports={installAndRun:installAndRun,installdbg:installdbg,installmkp:installmkp,runapp:runapp,getAvailablePlatform:getAvailablePlatform,getAllConnectedDevices:getAllConnectedDevices};
//# sourceMappingURL=debug.js.map
